package arrays;

/**
 * Title:        Array Beispiele
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

public class ArrayBeispiele {
  public static void main(String[] args) {

    // Grundschema :
    // deklarieren
    char c[];
    // kreieren
    c = new char[20];
    // initialisieren
    c[0]=' ';

    // Multidimensionale Arrays
    int iArray[][]=new int[4][5];
    System.out.println("Lnge  : "+iArray.length);
    System.out.println("Breite : "+iArray[0].length);
    // die Felder sind noch nicht initialisiert
    System.out.println("Datenelement : "+iArray[0][0]); // geht, weil die Elemente Basisdatentyp sind

    String strArray[]= new String[10];
    System.out.println("String Array : "+strArray[0]);  // String wird mit null initialisiert

    EineKlasse eEK[] = new EineKlasse[5];
    System.out.println("Objekt Array : "+eEK[0]);       // Objekt wird mit null initialisiert
    eEK[0] = new EineKlasse("Hallo");
    int iAnzahlInstanzen = eEK[0].iEK;
    System.out.println("Anzahl Instanzen : "+eEK[0].iEK+" oder "+eEK[0].iEK);
    eEK[1] = new EineKlasse("Nicole");
    System.out.println("Anzahl Instanzen : "+eEK[0].iEK+" oder "+eEK[1].iEK);
    eEK[2] = new EineKlasse("Britta");
    System.out.println("Anzahl Instanzen : "+eEK[0].iEK+" oder "+eEK[2].iEK);
    eEK[3] = new EineKlasse("Jens");
    System.out.println("Anzahl Instanzen : "+eEK[0].iEK+" oder "+eEK[3].iEK);

    // Array Copy
    // Memory abfragen
    Runtime rt = Runtime.getRuntime();
    long istFrei = rt.freeMemory();
    System.out.println("Freier Speicher vor Anlegen Array: "+istFrei);

    int elemente[ ]= new int[] {1,2,3,4,5,6};
    int l0 = elemente.length;
    System.gc();
    istFrei = rt.freeMemory();
    System.out.println("Freier Speicher vor arraycopy (nach Garbage Collector): "+istFrei);

    int neu[] = new int [] { 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
    int l1 = neu.length;
    // kopieren aller alten Elemente in das neue Array
    // Start beim Element 0; die initialisierten neuen Elemente
    // werden berschrieben
    System.arraycopy(elemente, 0, neu, 0, elemente.length);

    // neu enthlt : 1,2,3,4,5,6,4,3,2,1
    System.out.println("Neues Array : ");
    for (int ix=0; ix<neu.length; ix++) System.out.print(" "+neu[ix]);
    System.out.println("");
    long istNeuFrei = rt.freeMemory();
    System.out.println("Freier Speicher (nach arraycopy): "+istNeuFrei);

    System.gc();
    istNeuFrei = rt.freeMemory();
    System.out.println("Freier Speicher (nach arraycopy und gc): "+istNeuFrei);
    System.out.println("Speicherdifferenz: "+(istNeuFrei-istFrei)+" also pro neues int ELement : "+(-(istNeuFrei-istFrei)/(l1-l0))+" Bytes");

    // Arraycopy bei gleichem Typ und gleicher Lnge
    int[ ] eins = new int[] {0,1,2,3,4,5,6,7,8,9};
    int[ ] drei ={0,1,2,3,4,5,6,7,8}; // krzer
    int[ ] zwei = new int[10];
    zwei = eins;  // gleiche Referenz
    System.out.println("Element 0 : "+eins[0]+" "+zwei[0]);
    eins = null;  // Zugriff auf eins fhrt in Zukunft zu NullPointerException
    System.out.println("Element 0 : "+zwei[0]);
    //System.out.println("Ausgabe der Refenz eins: "+eins+" und des Namens : "+eins.getClass()+" ");
    System.out.println("Ausgabe der Refenz zwei: "+zwei+" und des Namens : "+zwei.getClass()+" ");
  }
}