package standardinitialisierungen;

/**
 * Title:        Standard-Initialisierungen
 * Description:  Welchen Wert haben Basisdatentypen
 * a) numerische
 * b) Boole'sche
 * und welchen Wert haben Objekte (inkl String)?
 * Copyright:    Copyright (c) J.M.Joller
 * Company:      Joller-Voss
 * @author J.M.Joller
 * @version 1.0
 */

public class Initialisierung {

  public static  void test(String strVar, Object objVar, boolean bVar, int iVar) {
    int iVarMem;
    boolean bVarMem;
    // Strings sind Objekte
    String strVarMem;
    Object objVarMem = new Object();
    /**
     * die folgende Ausgabe fhrt zu Syntaxfehler
     * weil die Variablen lokal sind

    System.out.println("Standardwerte bei der Initialisierung: \n"+
    "Numerische Variable:\t"+iVarMem+"\n"+
    "Boole'sche Variable:\t"+bVarMem+"\n"+
    "String Variable :   \t"+strVarMem+"\n"+
    "Objekt Variable :   \t"+objVarMem);
    */
    iVarMem=iVar;
    bVarMem=bVar;
    strVarMem=strVar;
    objVarMem=objVar;
    System.out.println("bergebene Werte bei der Initialisierung: \n"+
    "Numerische Variable:\t"+iVarMem+"\n"+
    "Boole'sche Variable:\t"+bVarMem+"\n"+
    "String Variable :   \t"+strVarMem+"\n"+
    "Objekt Variable :   \t"+objVarMem);
  }

  public static void main(String[] args) {

    // lokale Variablen mssen initialisiert werden
    /** Fehlerhaftes Programm
    int iVar;
    boolean bVar;
    // Strings sind Objekte
    String strVar;
    Object objVar = new Object();
    System.out.println("Standardwerte bei der Initialisierung: \n"+
    "Numerische Variable:\t"+iVar+"\n"+
    "Boole'sche Variable:\t"+bVar+"\n"+
    "String Variable :   \t"+strVar+"\n"+
    "Objekt Variable :   \t"+objVar);
    */
    int iVar=10;
    boolean bVar=true;
    // Strings sind Objekte
    String strVar="Hallo";
    Object objVar = new Object();
    Initialisierung.test(strVar,objVar,bVar,iVar);
  }
}